/**
 * Quadrilatero
 *      float L1, L2, L3, L4 
 *      getPerimetro(); // soma de todos os lados
 *
 *      Retangulo
 *      // definir 2 lados no contrutor 
 *      getArea(); 
 *
 *      Quadrado
 *      // definir 1 lado
 */
#include <iostream>
using namespace std;
class Quadrilatero {
protected:
    float L1;
    float L2;
    float L3;
    float L4;
public:
    Quadrilatero(float L1, float L2, float L3, float L4):
        L1(L1), L2(L2), L3(L3), L4(L4) {}
    
    float getPerimetro() {
        return L1 + L2 + L3 + L4;
    }
}; 

class Retangulo : public Quadrilatero {
public:
    Retangulo( float L1, float L2 ) : 
        Quadrilatero( L1, L1, L2, L2 ){}
    float getArea() {
        return L1 * L3;
    }
}; 
class Quadrado : public Retangulo {
public:
    Quadrado( float L1 ) : Retangulo( L1, L1 ){}
};

int main() {
    Quadrado q( 5 );
    cout << "Area: " << q.getArea() << endl;
    cout << "Perímetro: " << q.getPerimetro() << endl;
              
}
 
 

